<template>
	<f7-page 
        name="chatmessage" 
        @page:beforein="onPageBeforeIn" 
        no-toolbar
        infinite
        :infinite-top="true"
        :infinite-distance="0"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="chat != null" class="show-small-title">{{ user.id == chat.sender.id ? chat.recipient.profile.fullname : chat.sender.profile.fullname }}</f7-nav-title>
            <f7-nav-title-large>Chat</f7-nav-title-large>
		</f7-navbar>
        <f7-messagebar
            placeholder="Ketik pesan"
            ref="messagebar"
            :attachments-visible="medias.length > 0"
            :sheet-visible="false"
            style="max-height: 200px">
            <f7-link
                icon-ios="f7:attachment"
                icon-aurora="f7:attachment"
                icon-md="material:attachment"
                slot="inner-start"
                @click="handleUpload"
            ></f7-link>
            <f7-link
                icon-ios="f7:paper_plane"
                icon-aurora="f7:paper_plane"
                icon-md="material:send"
                slot="inner-end"
                @click="doSubmit"
            ></f7-link>
            <f7-messagebar-attachments>
                <f7-messagebar-attachment
                v-for="(image, index) in medias"
                :key="index"
                :image="image.url.original"
                @attachment:delete="handleMediaDelete(image.id)"
                ></f7-messagebar-attachment>
            </f7-messagebar-attachments>
        </f7-messagebar>
        <f7-messages ref="messages" :scrollMessages="false">
            <f7-message
                class="chat-message"
                v-for="(message, index) in messages"
                :key="index"
                :type="message.user.id == user.id ? 'sent' : 'received'"
                :name="message.user.id != message.chat.sender.id ? message.chat.recipient.profile.fullname : message.chat.sender.profile.fullname"
                :first="isFirstMessage(message, index)"
                :last="isLastMessage(message, index)"
                :tail="isTailMessage(message, index)"
            >
                <span slot="text" v-if="message.message" v-html="message.message">{{ message.message }}</span>

                <div v-if="message.medias.length > 0" slot="bubble-end">
                    <div v-if="message.medias.length > 0" class="attachments">
                        <a href="#" @click="handleAttachment($event, message)" class="attachment" v-for="media in message.medias" v-bind:key="media.id">
                            <img :src="media.url.small" width="64" class="img-rounded">
                        </a>
                    </div>
                </div>
                <small slot="content-end" class="message-date">{{ hoursAgo(message.updated) }}</small>
            </f7-message>
        </f7-messages>
        <f7-block v-if="messages.length == 0" style="height: calc(100% - 100px);position:absolute;top:0;left:0;width:100%;">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="speaker_notes_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, parseError, hoursAgo, truncate, stripHTML } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'ChatMessage',
    data(){
        return{
            allowInfinite: true,
            showPreloader: true,
            messageForm: {
                message: '',
                latitude: null,
                longitude: null,
                mapurl: null,
                medias: []
            },
            medias: []
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('chat', [
            'chat',
            'messages',
            'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    mounted() {
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        self.$f7ready(() => {
            self.messagebar = self.$refs.messagebar.f7Messagebar;
            self.messagesText = self.$refs.messages.f7Messages;
            
            $$('div[data-name="chatmessage"] textarea').on('focus', function(){
                var height = $$('.messages-content')[0].scrollHeight;
                $$('.messages-content').scrollTop( height, 1000 );
            });

            $$('div[data-name="chatmessage"]').on('click', 'a.geo', function(){
                let href = $$(this).data('href');
                location.href = href;
            });
        });
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        getAvatar(message){
            const self = this;
            if(message.user.id != self.user.id){
                if(message.user.id == message.chat.sender.id){
                    return message.chat.sender.profile.media != null ? message.chat.sender.profile.media.url.small : require('../assets/no-profile-photo.png');
                }else{
                    return message.chat.recipient.profile.media != null ? message.chat.recipient.profile.media.url.small : require('../assets/no-profile-photo.png');
                }
            }

            return;
        },
        isFirstMessage(message, index) {
            const self = this;
            const previousMessage = self.messages[index - 1];

            if(previousMessage == undefined) return true;

            const messageType = message.user.id != self.user.id ? 'received' : 'sent';

            if (!previousMessage || previousMessage.type !==  messageType || previousMessage.user.id !== message.user.id){
                return true;
            } 
            return false;           
        },
        isLastMessage(message, index) {
            const self = this;
            const nextMessage = self.messages[index + 1];

            if (nextMessage == undefined) return true;

            const messageType = message.user.id != self.user.id ? 'received' : 'sent';
            
            if (!nextMessage || nextMessage.type !==  messageType || nextMessage.user.id !== message.user.id){
                return true;
            } 
            return false;
        },
        isTailMessage(message, index) {
            const self = this;
            const nextMessage = self.messages[index + 1];
            if (nextMessage == undefined) return true;

            const messageType = message.user.id != self.user.id ? 'received' : 'sent';
            
            if (!nextMessage || nextMessage.type !==  messageType || nextMessage.user.id !== message.user.id){
                return true;
            } 
            return false;
        },
        getMessages(page, loadmore){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            var heightBefore = $$('.messages-content')[0].scrollHeight;

            app.preloader.show('green');

            self.$store.dispatch('chat/viewChatMessage', {
                id: self.$f7route.params.id,
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only:'id,message,latitude,longitude,mapurl,created,updated,medias.id,medias.url,chat.id,chat.sender.id,chat.sender.nid,chat.sender.profile.fullname,chat.sender.profile.media.id,chat.sender.profile.media.url,chat.recipient.id,chat.recipient.nid,chat.recipient.profile.fullname,chat.recipient.profile.media.id,chat.recipient.profile.media.url,user.id,user.nid'
            }).then((response) => {
                self.showPreloader = self.pagination.has_next;
                app.preloader.hide();   
                var heightAfter = $$('.messages-content')[0].scrollHeight;
                $$('.messages-content').scrollTop( (heightAfter - heightBefore), 1000 );             
            });
        },
        onPageBeforeIn(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);
            
            self.getMessages(1, false);

            const chat_channel = app.pusher.subscribe('chat');

            chat_channel.bind('message', function(data) {

                let user_id = null;

                if(data.user.id == self.chat.sender.id){ //sender ==> kirim ke recipient
                    user_id = self.chat.recipient.id;
                }else{
                    user_id = self.chat.sender.id;
                }

                if(self.messages && data.chat.id == self.chat.id && user_id == self.user.id){
                    self.messages.push(data);                    
                    setTimeout(()=>{
                        var heightAfter = $$('.messages-content')[0].scrollHeight;
                        $$('.messages-content').scrollTop( heightAfter, 1000 );
                    }, 100);
                    
                    const media = new Media('/android_asset/www/static/definite.mp3', null);
                    media.play();
                }
            });
            
        },
        handleUpload(){
			const self = this;
			const app = self.$f7;

			var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/message/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            self.messageForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/message/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        self.messageForm.medias.push(response.data.media.id);
                                        self.medias.push(response.data.media);

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Lokasi', 
                        onClick: function(action, e){
                            if(self.currentLocation != null){
                                self.commentForm.latitude = self.currentLocation.latitude;
                                self.commentForm.longitude = self.currentLocation.longitude;

                                app.dialog.alert('Lokasi berhasil dilampirkan. Silahkan tulis pesan untuk melanjutkan.', 'RingSatu');
                            }else{
                                app.dialog.alert('Gagal melakukan permintaan data lokasi. Silahkan aktifkan fitur lokasi dari handphone anda.', 'RingSatu');
                            }
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        },
        handleMediaDelete(imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				self.$store.dispatch('media/deleteMedia', {
					id: parseInt(imageId),
					endpoint: 'message'
				}).then((response) => {
					for(let [i,x] of self.medias){
                        if(x.id == imageId){
                            self.medias.splice(i, 1);
                        }
                    }
					app.preloader.hide();
				});
			})
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;
            setTimeout(()=>{
                if(self.pagination.has_next){                
                    self.getMessages(self.pagination.page + 1, true);
                    self.allowInfinite = true;
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        doSubmit(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            const message = self.messagebar.getValue().replace(/\n/g, '<br>').trim();
            if(message.length == 0) return;

            app.preloader.show('green');

			let params = {};

			params.message = message;
			params.latitude = self.messageForm.latitude;
            params.longitude = self.messageForm.longitude;
            params.mapurl = self.messageForm.mapurl;
            params.medias = self.messageForm.medias;
            params.id = parseInt(self.$f7route.params.id);
            only:'id,message,latitude,longitude,mapurl,created,updated,medias.id,medias.url,chat.id,chat.sender.id,chat.sender.nid,chat.sender.profile.fullname,chat.sender.profile.media.id,chat.sender.profile.media.url,chat.recipient.id,chat.recipient.nid,chat.recipient.profile.fullname,chat.recipient.profile.media.id,chat.recipient.profile.media.url,user.id,user.nid'

			self.$store.dispatch('chat/createChatMessage', params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{                    
                    self.messagebar.clear();
                    self.messageForm = {
                        message: '',
                        latitude: null,
                        longitude: null,
                        mapurl: null,
                        medias: []
                    };
                    self.medias = [];

                    var heightAfter = $$('.messages-content')[0].scrollHeight;
                    $$('.messages-content').scrollTop( heightAfter, 1000 );
				}
			});

        },
        handleAttachment(e, message){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            let attachmentMedias = message.medias.map((x) => x.url.original);
            let photoBrowser = app.photoBrowser.create({
                photos: attachmentMedias,
                type: 'popup'
            }).open();
        }
    }
}
</script>
